/*
 *
 *	GenLib
 *
 *	Ti-Gcc Header file
 *
 */


#ifndef	__GENLIB

#define SCREEN_X	30		// 'Real' Screen horizontal size in bytes
#define SCREEN_Y	128		// 'Real' Screen vertical   size in pixels
#define SCREEN_X_89	20		//  Screen horizontal size in bytes  on Ti-89
#define SCREEN_Y_89	100		//  Screen vertical   size in pixels on Ti-89
#define SCREEN_SIZE	SCREEN_X * SCREEN_Y // Size in bytes of a Screen
#define DSCREEN_SIZE	2*SCREEN_SIZE

#define VIRTUAL_X	34		// Horizontal VScreen size in pixels /8
#define VIRTUAL_Y	5*4		// Vertical   VScreen size in pixels /8
#define VSCREEN_SIZE	VIRTUAL_X * 8 * VIRTUAL_Y *2	// Size of a VScreen

#define MAX_HANDLE	20		// Max number of handles available in gl_handle stack

#define F_ONE		65536	

#define IN_PROGRESS	0		// Link recpt/send flag
#define DONE		1		// Link recpt/send flag

#define MASTER		0		// Main link_flag
#define SLAVE		1		// Main link_flag

#ifndef	HANDLE
typedef	HANDLE	unsigned short;
#endif

/* 
 * Those 2 struct must be 8x aligned
 */
typedef unsigned char SCREEN[SCREEN_SIZE];
typedef unsigned char DSCREEN[DSCREEN_SIZE];

typedef short	SPRITE_16[16][2];
typedef char	TILE_8[8][2];
typedef	short	SPRITE_BW16[16];
typedef	long	FAST_SPRITE[16][16];

typedef char	DHZ_TAB[SCREEN_Y];
typedef	short	HDZ_TAB[SCREEN_Y];

typedef	char	KEYBOARD[10];

typedef long	FIXED;

typedef struct
{
 HANDLE		handle; // Or unsigned short if Handle not defined
 unsigned short	size;
 unsigned char	*table;
 void		*tile;	// Either sprite_16 or tile_8 or ?
 unsigned char	*ind_tab;	// Don't use this !
 unsigned short	xs_old;		// Don't use this !
 unsigned short	ys_old;		// Don't use this !
 unsigned short	xs;
 unsigned short	ys;
 unsigned char	VScreen[VSCREEN_SIZE];
} PLANE;

typedef struct
{
 unsigned short	link_flag;
 unsigned char	*buffer_recpt;
 unsigned char	*buffer_send;
 unsigned short	buffer_recpt_size;
 unsigned short	buffer_send_size;
 unsigned char	buffer_recpt_flag;
 unsigned char	buffer_send_flag;
 unsigned short	buffer_recpt_offset;
 unsigned short	buffer_send_offset;
} LINK_DATA;

typedef struct
{
 char	Height; 		// In pixel
 char	Weight; 		// In pixel /16
 short	Data[1];		// Should be []
} BGS;

typedef struct
{
 unsigned int kh_key : 1;
 unsigned int kg_key : 1;
 unsigned int kf_key : 1;
 unsigned int ke_key : 1;
 unsigned int kd_key : 1;
 unsigned int kc_key : 1;
 unsigned int kb_key : 1;
 unsigned int ka_key : 1;	
 unsigned int down_key : 1;
 unsigned int right_key : 1;
 unsigned int up_key : 1;
 unsigned int left_key : 1;
 unsigned int minus_key : 1;
 unsigned int plus_key : 1;
 unsigned int mode_key : 1;
 unsigned int exit_key : 1;
} JOYPAD;

typedef struct
{
 short x;
 short y;
} POINT;

/*
 * Functions without any macros
 * i.e. functions which don't have arguments
 */

#define gl_init 		genlib__0000
#define gl_quit 		genlib__0001
#define gl_exg_gray 		genlib__001D
#define gl_set_LCD_MEM		genlib__0032

#define gl_copy_window		genlib__0005
#define gl_cls			genlib__0028
#define gl_clear_window		genlib__004A

#define gl_change_update	genlib__0045
#define gl_restore_update	genlib__0046

#define gl_wait_no_key		genlib__000E
#define gl_wait_a_key		genlib__000F
#define gl_keypressed		genlib__001A
#define gl_read_key_matrix	genlib__0034
#define gl_read_joypad		genlib__0035

#define gl_set_byte_link	genlib__002C
#define gl_receive_byte		genlib__002E
#define gl_send_data		genlib__002F
#define gl_synchronize		genlib__0030

#define gl_pop_hd		genlib__0039
#define gl_free_hd		genlib__003A

void	gl_init(void);
void	gl_quit(void);

void	gl_exg_gray(void);

void	gl_cls(void);
void	gl_clear_window(void);
void	gl_set_LCD_MEM(void);
void	gl_copy_window(void);

void	gl_wait_no_key(void);
void	gl_wait_a_key(void);
char	gl_key_pressed(void);
KEYBOARD *gl_read_key_matrix(void);
JOYPAD	gl_read_joypad(void);

void	gl_set_byte_link(void);
char	gl_receive_byte(void);
void	gl_send_data(void);
char	gl_synchronize(void);

void	gl_free_hd(void);
HANDLE	gl_pop_hd(void);

void	gl_change_update(void);
void	gl_restore_update(void);



/*
 * Macros / Functions def
 * These macros exist also under the form of 'pseudo' functions.
 *
 * Warning : Use them at your own risk !
 */

#define _gl_init_screen(Screen, Handle_adr) \
	asm("jsr genlib__0049 \n move.l %%a0,(%0) \n move.w %%d0,(%1)" :: "a" (Screen), "a" (Handle_adr) : "d0", "d1", "d2", "a0", "a1")
#define _gl_init_dscreen(DScreen, Handle_adr) \
	asm("jsr genlib__0002 \n move.l %%a0,(%0) \n move.w %%d0,(%1)" :: "a" (DScreen), "a" (Handle_adr) : "d0", "d1", "d2", "a0", "a1")

#define _gl_set_screen_int(Scr1, Scr2, Scr3) \
	asm("move.l %0, %%d0 \n move.l %1,%%d1 \n move.l %2,%%d2 \n jsr	genlib__0043" :: "d" (Scr1), "d" (Scr2), "d" (Scr3) : "d0", "d1", "d2")
#define _gl_set_dscreen_int(DScr) \
	asm("move.l %0,%%d0 \n jsr genlib__0003" :: "d" (DScr) : "d0")
#define _gl_set_dscreen_function(DScr) \
	asm("move.l %0,%%d0 \n jsr genlib__0004" :: "d" (DScr) : "d0")

#define _gl_push_hd(Hd) \
	asm("move.w %0,%%d0 \n jsr genlib__0038" :: "d" (Hd) : "d0", "d1")
	
#define	_gl_put_small_string(Screen, x, y, String) \
	asm ("move.l %0, %%a0 \n move.l %1, %%a1 \n move.w %2, %%d0 \n move.w %3, %%d1 \n jsr genlib__003E" :: "a" (String), "a" (Screen), "d" (x), "d" (y) : "a0", "a1", "d0", "d1")
#define	_gl_put_medium_string(Screen, x, y, String) \
	asm ("move.l %0, %%a0 \n move.l %1, %%a1 \n move.w %2, %%d0 \n move.w %3, %%d1 \n jsr genlib__003F" :: "a" (String), "a" (Screen), "d" (x), "d" (y) : "a0", "a1", "d0", "d1")
#define	_gl_put_large_string(Screen, x, y, String) \
	asm ("move.l %0, %%a0 \n move.l %1, %%a1 \n move.w %2, %%d0 \n move.w %3, %%d1 \n jsr genlib__0040" :: "a" (String), "a" (Screen), "d" (x), "d" (y) : "a0", "a1", "d0", "d1")

#define _gl_put_sprite_16(x, y, nbr) \
	asm("move.w %0, %%d0 \n	move.w %1, %%d1 \n move.w %2, %%d2 \n jsr genlib__0009" :: "d" (x), "d" (y), "d"(nbr) : "d0", "d1", "d2")
#define	_gl_put_sprite_16_flip_h(x, y, nbr) \
	asm("move.w %0, %%d0 \n	move.w %1, %%d1 \n move.w %2, %%d2 \n jsr genlib__0011" :: "d" (x), "d" (y), "d"(nbr) : "d0", "d1", "d2")
#define _gl_put_sprite_16_flip_v(x, y, nbr) \
	asm("move.w %0, %%d0 \n	move.w %1, %%d1 \n move.w %2, %%d2 \n jsr genlib__0012" :: "d" (x), "d" (y), "d"(nbr) : "d0", "d1", "d2")
#define _gl_put_sprite_16_flip_hv(x, y, nbr) \
	asm("move.w %0, %%d0 \n	move.w %1, %%d1 \n move.w %2, %%d2 \n jsr genlib__0013" :: "d" (x), "d" (y), "d"(nbr) : "d0", "d1", "d2")

#define _gl_put_big_sprite(x, y, bgs) \
	asm("move.w %0, %%d0 \n move.w %1, %%d1 \n move.l %2, %%a0 \n jsr genlib__0014" :: "d" (x), "d" (y), "a" (bgs) : "d0", "d1", "a0")
#define _gl_put_big_sprite_flip_h(x, y, bgs, bgs_flip) \
	asm("move.w %0, %%d0 \n move.w %1, %%d1 \n move.l %2, %%a0 \n move.l %3,%%a1 \n jsr genlib__0015" :: "d" (x), "d" (y), "a" (bgs_flip), "a" (bgs) : "d0", "d1", "a0", "a1")
#define _gl_put_big_sprite_flip_v(x, y, bgs, bgs_flip) \
	asm("move.w %0, %%d0 \n move.w %1, %%d1 \n move.l %2, %%a0 \n move.l %3,%%a1 \n jsr genlib__0016" :: "d" (x), "d" (y), "a" (bgs_flip), "a" (bgs) : "d0", "d1", "a0", "a1")
#define _gl_put_big_sprite_flip_hv(x, y, bgs, bgs_flip) \
	asm("move.w %0, %%d0 \n move.w %1, %%d1 \n move.l %2, %%a0 \n move.l %3,%%a1 \n jsr genlib__0017" :: "d" (x), "d" (y), "a" (bgs_flip), "a" (bgs) : "d0", "d1", "a0", "a1")

#define _gl_set_spr_xy(x, y) \
	asm("move.w %0, genlib__000B+2 \n move.w %1,genlib__000C+2" :: "d" (x), "d" (y))
#define _gl_set_spr_tile(tile_adr) \
	asm("move.l %0,genlib__000A+2" :: "a" (tile_adr))

#define _gl_send_byte(oct) \
	asm("move.b %0, %%d0 \n jsr genlib__002D" :: "d" (oct): "d0")
#define	_gl_set_link(buf_rcpt, buf_send, buf_rept_len, buf_send_len) \
	asm("move.l %0, %%a1 \n move.l %1, %%a2 \n move.w %2, %%d1 \n move.w %3, %%d2 \n jsr genlib__0033" :: "a" (buf_recpt), "a" (buf_send), "d" (buf_recpt_len), "d" (buf_send_len): "d1", "d2", "a1", "a2")

#define _gl_put_pixel(P, color) \
	asm("move.w (%0),%%d0 \n move.w 2(%0),%%d1 \n move.w %1,%%d3 \n jsr genlib__002B" :: "a" (P), "d" (color) : "d0", "d1", "d3")
#define _gl_draw_circle(P, radius, color) \
	asm("move.l %%d5, -(%%a7) \n move.w (%0), %%d4 \n move.w %1, %%d2 \n move.w %2, %%d3 \n move.w 2(%0), %%d5 \n jsr genlib__004B \n move.l (%%a7)+, %%d5" :: "a" (P), "d" (radius), "d" (color) : "d2", "d3", "d4")
#define _gl_draw_clipped_circle(P, radius, color) \
	asm("move.l %%d5, -(%%a7) \n move.w (%0), %%d4 \n move.w %1, %%d2 \n move.w %2, %%d3 \n move.w 2(%0), %%d5 \n jsr genlib__004C \n move.l (%%a7)+, %%d5" :: "a" (P), "d" (radius), "d" (color) : "d2", "d3", "d4")

#define _gl_make_fast_sprite(Spr, fspr) \
	asm("move.l %%0, %%a0 \n move.l %%1, %%a1 \n jsr genlib__0024" :: "a" (Spr), "a" (fspr) : "a0", "a1")

#define _gl_init_plane(map, tile, sizeX, Plan) \
	asm("move.w %0,%%d3 \n move.l %1,%%a4 \n move.l %2,%%a3 \n move.l %%a5,-(%%sp) \n suba.l %%a5,%%a5 \n jsr genlib__0006 \n move.l (%%sp)+, %%a5 \n move.l %%a0,(%3)" :: "d" (sizeX), "d" (tile), "d" (map), "a" (Plan) : "d0", "d3", "a3", "a4")
#define _free_plane(P) \
	asm("move.l %0,%%a0 \n jsr genlib__0007" :: "a" (P) : "d0", "d1", "d2", "a0", "a1")
#define _gl_refresh_plane(P) \
	asm("move.l %0,%%a0 \n jsr genlib__0008" :: "a" (P) : "a0")
#define _gl_copy_xyplane_xysprite(P) \
	asm("move.l %0,%%a0 \n jsr genlib__001B" :: "a" (P) : "a0")
#define _gl_copy_dscreen_vscreen(P, Scr) \
	asm("move.l %0,%%a0 \n move.l %1,%%a1 \n jsr genlib__001B" :: "a" (P), "a" (Scr) : "a0", "a1")

#define _gl_update_vscreen_8(P) \
	asm("move.l %0,%%a0 \n jsr genlib__0019" :: "a" (P) : "a0")
#define _gl_update_vscreen_16(P) \
	asm("move.l %0,%%a0 \n jsr genlib__001C" :: "a" (P) : "a0")
#define _gl_update_roll_vscreen_16(P) \
	asm("move.l %0,%%a0 \n jsr genlib__003D" :: "a" (P) : "a0")

#define _gl_put_plane(P) \
	asm("move.l %0,%%a0 \n movem.l %%d0-%%d5/%%a1-%%a5,-(%%sp) \n jsr genlib__0010 movem.l(%%sp)+,%%d0-%%d5/%%a1-%%a5" :: "a" (P) :"a0")
#define _gl_put_plane_89(P) \
	asm("move.l %0,%%a0 \n movem.l %%d0-%%d5/%%a1-%%a5,-(%%sp) \n jsr genlib__0020 movem.l(%%sp)+,%%d0-%%d5/%%a1-%%a5" :: "a" (P) :"a0")
#define _gl_put_frgd_plane(P) \
	asm("move.l %0,%%a0 \n movem.l %%d0-%%d5/%%a1-%%a5,-(%%sp) \n jsr genlib__001E movem.l (%%sp)+,%%d0-%%d5/%%a1-%%a5" :: "a" (P) : "a0")
#define _gl_put_frgd_plane_89(P) \
	asm("move.l %0,%%a0 \n movem.l %%d0-%%d5/%%a1-%%a5,-(%%sp) \n jsr genlib__0021 movem.l (%%sp)+,%%d0-%%d5/%%a1-%%a5" :: "a" (P) : "a0")
#define _gl_put_dhz_plane(P, Dhz, Hdz) \
	asm("move.l %2,%%a5 \n move.l %1,%%a4 \n move.l %0,%%a0 \n jsr genlib__0022" :: "a" (P), "d" (Dhz), "d" (Hdz) : "a0", "a4", "a5")
#define _gl_put_dhz_plane_89(P, Dhz, Hdz) \
	asm("move.l %2,%%a5 \n move.l %1,%%a4 \n move.l %0,%%a0 \n jsr genlib__003B" :: "a" (P), "d" (Dhz), "d" (Hdz) : "a0", "a4", "a5")
#define _gl_put_dhz_frgd_plane(P, Dhz, Hdz) \
	asm("movem.l %%d7/%%a6,-(%%sp) \n move.l %2,%%d7 \n move.l %1,%%a6 \n move.l %0,%%a0 \n jsr genlib__0023 \n movem.l (%%sp)+,%%d7/%%a6" :: "a" (P), "d" (Dhz), "d" (Hdz) : "a0")
#define _gl_put_dhz_frgd_plane_89(P, Dhz, Hdz) \
	asm("movem.l %%d7/%%a6,-(%%sp) \n move.l %2,%%d7 \n move.l %1,%%a6 \n move.l %0,%%a0 \n jsr genlib__003C \n movem.l (%%sp)+,%%d7/%%a6" :: "a" (P), "d" (Dhz), "d" (Hdz) : "a0")
#define _gl_put_dhz_trpt_plane(P, Dhz, Hdz, Dhz_o, Hdz_o) \
	asm("movem.l %%a3-%%a6,-(%%sp) \n move.l %4,%%a6 \n move.l %3,%%a5 \n move.l %2,%%a4 \n move.l %1,%%a3 \n move.l %0,%%a0 \n jsr	genlib__0047 \n movem.l	(%%sp)+,%%a3-%%a6" :: "a" (P), "a" (Dhz), "d" (Hdz), "d" (Dhz_o), "d" (Hdz_o) : "a0")
#define _gl_put_dhz_trpt_plane_89(P, Dhz, Hdz, Dhz_o, Hdz_o) \
	asm("movem.l %%a3-%%a6,-(%%sp) \n move.l %4,%%a6 \n move.l %3,%%a5 \n move.l %2,%%a4 \n move.l %1,%%a3 \n move.l %0,%%a0 \n jsr	genlib__0048 \n movem.l	(%%sp)+,%%a3-%%a6" :: "a" (P), "a" (Dhz), "d" (Hdz), "d" (Dhz_o), "d" (Hdz_o) : "a0")
#define _gl_set_filter(filt) \
	asm("move.w %0, %%d0 \n jsr genlib__0053" :: "d" (filt): "d0")




/* External variables */
#define gl_window		genlib__0041
#define gl_timer		genlib__000D
#define gl_hardware		genlib__0044
#define gl_link_data		genlib__0031
#define gl_sin			genlib__0054
#define gl_cos			genlib__0055

extern signed char	gl_sin[256];
extern signed char	gl_cos[256];
extern SCREEN		*gl_window; 
extern unsigned short	gl_hardware;
extern char		gl_internal_timer;
extern volatile unsigned long	gl_timer;
extern volatile LINK_DATA	gl_link_data;

#endif

